import { Box, styled } from "@styled-system/jsx";

import { Metadata } from "next";
import RichText from "@/components/rich-text";
import { getAbout } from "@/api";

export default async function About() {
  const about = await getAbout();

  return (
    <Box>
      <styled.h1></styled.h1>
      <RichText content={about.text!} />
    </Box>
  );
}

export async function generateMetadata(): Promise<Metadata> {
  const about = await getAbout();

  return {
    title: about.name,
  };
}
