import type { CollectionConfig } from "payload";
import { Menu } from "../groups/Menu";

export const FoodDeclaration: CollectionConfig = {
  slug: "food-declaration",
  access: {
    read: () => true,
  },
  admin: {
    useAsTitle: "title",
    group: Menu,
  },
  fields: [
    {
      name: "title",
      type: "text",
      required: true,
      localized: true,
    },
    {
      name: "description",
      type: "richText",
      localized: true,
    },
  ],
};
