import type { CollectionConfig } from "payload";
import { Menu } from "../groups/Menu";

export const MenuItemTag: CollectionConfig = {
  slug: "menu-item-tag",
  access: {
    read: () => true,
  },
  admin: {
    useAsTitle: "name",
    group: Menu,
  },
  fields: [
    {
      name: "name",
      type: "text",
      required: true,
      localized: true,
    },
    {
      name: "description",
      type: "richText",
      localized: true,
    },
  ],
};
