import type { CollectionConfig, Option } from "payload";

export const DayOptions: Option[] = [
  {
    label: "Monday",
    value: "0",
  },
  {
    label: "Tuesday",
    value: "1",
  },
  {
    label: "Wednesday",
    value: "2",
  },
  {
    label: "Thursday",
    value: "3",
  },
  {
    label: "Friday",
    value: "4",
  },
  {
    label: "Saturday",
    value: "5",
  },
  {
    label: "Sunday",
    value: "6",
  },
];

export const OpeningTime: CollectionConfig = {
  slug: "opening-time",
  access: {
    read: () => true,
  },
  admin: {
    defaultColumns: ["from", "to", "timeOpen", "timeClose"],
  },
  fields: [
    {
      name: "from",
      type: "select",
      options: DayOptions,
      required: true,
    },
    {
      name: "to",
      type: "select",
      options: DayOptions,
    },
    {
      name: "timeOpen",
      type: "date",
      required: true,
      admin: {
        date: {
          pickerAppearance: "timeOnly",
          displayFormat: "h:mm:ss a",
        },
      },
    },
    {
      name: "timeClose",
      type: "date",
      required: true,
      admin: {
        date: {
          pickerAppearance: "timeOnly",
          displayFormat: "h:mm:ss a",
        },
      },
    },
  ],
};
