"use client";

import { useChangeLocale, useCurrentLocale, useI18n } from "@/i18n/client";

import { Button } from "@/components/ui/button";
import { Menu } from "@/components/ui/menu";
import { locales } from "@/i18n/settings";

export default function LanguagePicker(props: Menu.RootProps) {
  const changeLocale = useChangeLocale();
  const locale = useCurrentLocale();
  const t = useI18n();

  return (
    <Menu.Root {...props} positioning={{ offset: { crossAxis: -35 } }}>
      <Menu.Trigger asChild>
        <Button variant="outline" size={props.size}>
          {t(`general.${locale}`)}
        </Button>
      </Menu.Trigger>
      <Menu.Positioner>
        <Menu.Content right={0}>
          <Menu.ItemGroup>
            {locales.map((locale) => (
              <Menu.Item asChild key={locale} value={locale} onClick={() => changeLocale(locale)}>
                <Button>{t(`general.${locale}`)}</Button>
              </Menu.Item>
            ))}
          </Menu.ItemGroup>
        </Menu.Content>
      </Menu.Positioner>
    </Menu.Root>
  );
}
