import Link, { LinkProps } from "next/link";
import { RecipeVariantProps, cva, cx } from "@styled-system/css";

import { AnchorHTMLAttributes } from "react";

const variants = cva({
  base: { _hover: { color: "gray.800" } },
  variants: {
    type: {
      button: {
        background: "accent.9",
        color: "white",
        p: 2,
        borderRadius: "md",
        _hover: {
          background: "accent.11",
        },
      },
    },
  },
});

export default function NavLink({
  className,
  children,
  type,
  ...props
}: RecipeVariantProps<typeof variants> &
  Omit<AnchorHTMLAttributes<HTMLAnchorElement>, keyof LinkProps> &
  LinkProps) {
  return (
    <Link className={cx(variants({ type }), className)} {...props}>
      {children}
    </Link>
  );
}
